#include <vcl.h>
#pragma hdrstop
#include "GetApplicationVersion.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TApplicationVersion::TApplicationVersion(AnsiString FileName)
{
avFileName = FileName;

avCompanyName       = VersionInfoByKey("CompanyName");
avFileDescription   = VersionInfoByKey("FileDescription");
avFileVersion       = VersionInfoByKey("FileVersion");
avInternalName      = VersionInfoByKey("InternalName");
avLegalCopyright    = VersionInfoByKey("LegalCopyright");
avLegalTrademarks   = VersionInfoByKey("LegalTrademarks");
avOriginalFilename  = VersionInfoByKey("OriginalFilename");
avProductName       = VersionInfoByKey("ProductName");
avProductVersion    = VersionInfoByKey("ProductVersion");
avComments          = VersionInfoByKey("Comments");

lnLanguage          = GetApplicationLanguage();

dtCreate        = DateOfCreate(avFileName);
dtModified      = DateOfModified(avFileName);
dtLastAccess    = DateOfLastAccess(avFileName);
}
//---------------------------------------------------------------------------
__fastcall TApplicationVersion::~TApplicationVersion(void)
{
}
//---------------------------------------------------------------------------
#pragma option -w-rvl
AnsiString __fastcall TApplicationVersion::VersionInfoByKey(AnsiString avKey)
{
DWORD Size = GetFileVersionInfoSize(avFileName.c_str(), 0);

if(Size != 0)
    {
    char *buf = (char*)GlobalAlloc(GMEM_FIXED, Size);

    if(GetFileVersionInfo(avFileName.c_str(), 0, Size, buf) != 0)
        {
        char *ValueBuf;
        UINT Len;
        VerQueryValue(buf, "\\VarFileInfo\\Translation", &(void*)ValueBuf, &Len);
        if(Len >= 4)
            {
            AnsiString CharSet = IntToHex((int)MAKELONG(*(int*)(ValueBuf + 2), *(int*)ValueBuf), 8);
            if(VerQueryValue(buf, AnsiString("\\StringFileInfo\\" + CharSet + "\\" + avKey).c_str(), &(void*)ValueBuf, &Len) != 0)
                {
                AnsiString Result = AnsiString(ValueBuf);
                if (AnsiString(ValueBuf).IsEmpty())
                    {
                    return avKey + " - not found";
                    }
                else
                    {
                    return Result;
                    }
                }
            }
        }
    GlobalFree(buf);
    }
else
    {
    return avKey + " - not found";
    }
}
//---------------------------------------------------------------------------
AppLanguage __fastcall TApplicationVersion::GetApplicationLanguage(void)
{
AppLanguage lang;

DWORD Size = GetFileVersionInfoSize(avFileName.c_str(), 0);
if(Size != 0)
    {
    char *buf = (char*)GlobalAlloc(GMEM_FIXED, Size);

    if(GetFileVersionInfo(avFileName.c_str(), 0, Size, buf) != 0)
        {
        char *ValueBuf;
        UINT Len;
        VerQueryValue(buf, "\\VarFileInfo\\Translation", &(void*)ValueBuf, &Len);
        if(Len >= 4)
            {
            AnsiString tmp = IntToHex((int)MAKELONG(*(int*)(ValueBuf + 2), *(int*)ValueBuf), 8);
            AnsiString CharSet = "";
            CharSet += tmp[1];
            CharSet += tmp[2];
            CharSet += tmp[3];
            CharSet += tmp[4];
            AnsiString hex = "0x0000" + CharSet;
            lang.lngHex = hex;
            lang.lngStr = Languages()->NameFromLCID[hex];
            }
        }
    return lang;
    }
else
    {
    lang.lngHex = "Language not found";
    lang.lngStr = "Language not found";
    return lang;
    }
}
//---------------------------------------------------------------------------
TDateTime __fastcall TApplicationVersion::FileTimeToDateTime(FILETIME *lpftime)
{
FILETIME localfiletime;
SYSTEMTIME systime;
FileTimeToLocalFileTime(lpftime,&localfiletime);
FileTimeToSystemTime(&localfiletime,&systime);
TDateTime dt = NULL;
dt += TDateTime(systime.wYear, systime.wMonth, systime.wDay);
dt += TDateTime(systime.wHour, systime.wMinute, systime.wSecond, systime.wMilliseconds);
return dt;
}
//---------------------------------------------------------------------------
TDateTime __fastcall TApplicationVersion::DateOfCreate(AnsiString aFile)
{
FILETIME ftCreationTime;
HANDLE hFile = (HANDLE)FileOpen(aFile, fmOpenRead);
GetFileTime(hFile, &ftCreationTime, NULL, NULL);
return (FormatDateTime("c", FileTimeToDateTime(&ftCreationTime)));
}
//---------------------------------------------------------------------------
TDateTime __fastcall TApplicationVersion::DateOfModified(AnsiString aFile)
{
FILETIME ftModified;
HANDLE hFile = (HANDLE)FileOpen(aFile, fmOpenRead);
GetFileTime(hFile, NULL, &ftModified, NULL);
return (FormatDateTime("c", FileTimeToDateTime(&ftModified)));
}
//---------------------------------------------------------------------------
TDateTime __fastcall TApplicationVersion::DateOfLastAccess(AnsiString aFile)
{
FILETIME ftLAccess;
HANDLE hFile = (HANDLE)FileOpen(aFile, fmOpenRead);
GetFileTime(hFile, NULL, NULL, &ftLAccess);
return (FormatDateTime("c", FileTimeToDateTime(&ftLAccess)));
}
//---------------------------------------------------------------------------
