#ifndef GetApplicationVersionH
#define GetApplicationVersionH
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
//   
struct AppLanguage
{
    AnsiString lngHex;//0x00000419
    AnsiString lngStr;//Russian, for example
};
//---------------------------------------------------------------------------
class TApplicationVersion
{
protected:
    //  name of selected file
    AnsiString avFileName;
    
    //information by category
    AnsiString avCompanyName;
    AnsiString avFileDescription;
    AnsiString avFileVersion;
    AnsiString avInternalName;
    AnsiString avLegalCopyright;
    AnsiString avLegalTrademarks;
    AnsiString avOriginalFilename;
    AnsiString avProductName;
    AnsiString avProductVersion;
    AnsiString avComments;

    //Other information
    AppLanguage lnLanguage;
    TDateTime dtCreate;
    TDateTime dtModified;
    TDateTime dtLastAccess;

    //  functions
    AnsiString  __fastcall VersionInfoByKey(AnsiString avKey);
    AppLanguage __fastcall GetApplicationLanguage(void);

    TDateTime   __fastcall FileTimeToDateTime(FILETIME *lpftime);

    TDateTime   __fastcall DateOfCreate(AnsiString aFile);
    TDateTime   __fastcall DateOfModified(AnsiString aFile);
    TDateTime   __fastcall DateOfLastAccess(AnsiString aFile);
public:
    __fastcall  TApplicationVersion(const AnsiString FileName);
    __fastcall  ~TApplicationVersion(void);

    //  main
    __property  AnsiString CompanyName = {read = avCompanyName};
    __property  AnsiString FileDescription = {read = avFileDescription};
    __property  AnsiString FileVersion = {read = avFileVersion};
    __property  AnsiString InternalName = {read = avInternalName};
    __property  AnsiString LegalCopyright = {read = avLegalCopyright};
    __property  AnsiString LegalTrademarks = {read = avLegalTrademarks};
    __property  AnsiString OriginalFilename = {read = avOriginalFilename};
    __property  AnsiString ProductName = {read = avProductName};
    __property  AnsiString ProductVersion = {read = avProductVersion};
    __property  AnsiString Comments = {read = avComments};

    //  addition information, dates
    __property  TDateTime Create = {read = dtCreate};
    __property  TDateTime Modified = {read = dtModified};
    __property  TDateTime LastAccess = {read = dtLastAccess};

    //  language
    __property  AppLanguage Language = {read = lnLanguage};
};
